//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdlib.h>
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "zPanel"
#pragma link "SlideBar"
#pragma resource "*.dfm"
TForm1 *Form1;

AnsiString part1="0000",part2="0000",part3="0000",part4="0000",
base,base1;

unsigned int  gr1, gr2, gr3, gr4,remainder,quoz1,quoz2,square1,
square2,ebx1,ebx2,gr1p, gr3p, square3, square4, quoz3, quoz4,ebx3, ebx4,
t1,t2,t3=0,t4,t5,t6,t7,gr1q,gr3q;

int Kpr, Kpnum,beam[1000];

char *puntgr1,*puntgr2,*puntgr3,*puntgr4,*puntot;

char chgr1,chgr2,chgr3,chgr4;

bool flag = false, flagt2=false, step =false,minmax=false;

int const inkpr=52546810, trnot1=202923096, trnot2=1441947663,
trnot3=902719666, trnot4=524217594;

//estrae i quattro gruppi dal serial per visualizzarli
AnsiString estrai(int parte, AnsiString stato)
{AnsiString estratto;
estratto=stato.SubString(((parte-1)*4)+1,4);
return estratto;
};

//riordina i codici ASCII per ognuno dei quattro gruppi
//e pone il corrispondente decimale nelle relative variabili
void aggiorna_gruppi(void)
{
puntot=base.c_str();
gr1=StrToInt("0x"+IntToHex(puntot[3],2)+IntToHex(puntot[2],2) +
IntToHex(puntot[1],2)+IntToHex(puntot[0],2)) ;
gr2=StrToInt("0x"+IntToHex(puntot[7],2)+IntToHex(puntot[6],2) +
IntToHex(puntot[5],2)+IntToHex(puntot[4],2)) ;
gr3=StrToInt("0x"+IntToHex(puntot[11],2)+IntToHex(puntot[10],2) +
IntToHex(puntot[9],2)+IntToHex(puntot[8],2)) ;
gr4=StrToInt("0x"+IntToHex(puntot[15],2)+IntToHex(puntot[14],2) +
IntToHex(puntot[13],2)+IntToHex(puntot[12],2)) ;
};

//incrementa il serial, sempre relativamente all'intervallo
//compreso tra '0' e 'z' per ogni carattere
int passa_avanti (int t)
{
puntot[t]=puntot[t]+1;
flag=false;

 if (puntot[t]>122)
        {
                puntot[t]=48;
                t=t-1;
                t=passa_avanti(t);
        };

 if (t<0)
        flagt2=true;

return t;
};


//calcola Kpr
int Kpr_func( int g1,  int g2, int g3,  int g4)
{
 int result;

 result = abs(StrToInt("0x"+IntToHex((g1+g2-1)*(g3+g4),8)))-inkpr ;

 return result;
};

//ruota a sinistra di cinque posizioni
int ruotasin (int registxd)
{

int tempdisp, i, oring, regdisplayd;
unsigned int short primocarattere;
AnsiString carchar, inter1;


for (i=1;i<6;i++)
{
        inter1= "0x"+IntToHex(registxd,8);
        carchar = inter1.SubString(1,3);

        primocarattere=StrToInt(carchar);
        if (primocarattere>0x7)
                oring=1;
        else
                oring =0;
        tempdisp=registxd<<1;
        regdisplayd=tempdisp|oring;
        registxd=regdisplayd;
};

return regdisplayd;
};


//ruota a destra di quattro posizioni
int ruotades (int registxd)
{
int  i, oring, tempdisp, regdisplayd;

for (i=1;i<5;i++)
        {
                if ((registxd%2)==0)
                        oring=0;
                else
                        oring =0x80000000;

                tempdisp=registxd;
                tempdisp=tempdisp>>1;
                regdisplayd=tempdisp|oring;
                registxd=regdisplayd;
};

return regdisplayd;

};

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
int t, s, tempcount1, tempcount2;

base1=Edit1->Text;
Button1->Enabled=false;
Button2->Enabled=false;
Button3->Enabled=false;
Panel1->Font->Color=clBlue;
Panel2->Font->Color=clBlue;
Panel3->Font->Color=clBlue;
Panel4->Font->Color=clBlue;
t2=16;
base=base1;
flagt2=false;

while (flagt2==false)
{
while (base!="zzzzzzzzzzzzzzzz")

{
 flag =true;
 aggiorna_gruppi();
 Kpr=abs(Kpr_func(gr1,gr2,gr3,gr4));
 Kpnum=Kpr+inkpr;
 if (minmax==false)
        {
         Panel7->Caption=IntToStr(Kpr);
         Panel6->Caption=IntToStr(Kpr);
         minmax=true;
        };
remainder=Kpr%255;
if (remainder!=0)
        {
         tempcount1=(Kpnum/20)%8;
         tempcount2=(Kpnum/20)%160;
         gr3q=gr3;
         gr1q=gr1;
         for (s=1;s<tempcount1+1;s++)
                {
                 gr3p=ruotades(gr3q);
                 gr3q=gr3p;
                };

        if (tempcount1==0)
                gr3p=gr3;

        for (s=1;s<tempcount2+1;s++)
                {
                 gr1p=ruotasin(gr1q);
                 gr1q=gr1p;
                };

         if (tempcount2==0)
                gr1p=gr1;
        gr3p=gr3q;
        gr1p=gr1q;
//qui la funzione 'abs'  necessaria solo in C++Builder dalla versione 4 in poi
        square1=StrToInt("0x"+IntToHex(abs(gr1p*gr1p),8));
        square3=StrToInt("0x"+IntToHex(abs(gr3p*gr3p),8));
        square2=StrToInt("0x"+IntToHex(abs(gr2*gr2),8));
        square4=StrToInt("0x"+IntToHex(abs(gr4*gr4),8));
//I termine
        quoz1=square1/remainder;
        quoz3=square3/remainder;
        quoz2=square2/remainder;
        quoz4=square4/remainder;
//II termine
        ebx1=quoz1*Kpr;
        ebx3=quoz3*Kpr;
        ebx2=quoz2*Kpr;
        ebx4=quoz4*Kpr;
//valore finale
        t6=gr1p-ebx1;
        t7=gr3p-ebx3;
        t4=gr2-ebx2;
        t5=gr4-ebx4;

        if (Kpr<StrToInt(Panel6->Caption))
                Panel6->Caption=IntToStr(Kpr);

        if (Kpr>StrToInt(Panel7->Caption))
                Panel7->Caption=IntToStr(Kpr);

//il programma si ferma:
// - se ha trovato un serial valido
// - se ha gi calcolato i parametri per 50 serial
// - se  in modalit step

        if (((t4==trnot2)&&(t5==trnot4)&&(t6==trnot1)&&(t7==trnot3))
              ||(t3%50==0)||(step==true))

                {
//se il serial  stato trovato, i valori vengono visualizzati in rosso
                        if ((t4==trnot2)&&(t5==trnot4)&&(t6==trnot1)&&(t7==trnot3))
                                {
                                  Panel1->Font->Color=clRed;
                                  Panel2->Font->Color=clRed;
                                  Panel3->Font->Color=clRed;
                                  Panel4->Font->Color=clRed;
                };



          Panel1->Caption=estrai(1,base);
          Panel2->Caption=estrai(2,base);
          Panel3->Caption=estrai(3,base);
          Panel4->Caption=estrai(4,base);
          base1=base;
          base="zzzzzzzzzzzzzzzz";
          flagt2=true;
          Button1->Enabled=true;
          Button2->Enabled=true;
          Button3->Enabled=true;
          Edit1->Text=base1;
          step=false;

        }; 
//zSlideBar1->Value contiene il valore di scala dell'asse x
         for (t=0;t<zSlideBar1->Value+1;t++)
                {
                 zScope1->Channel1= (t4/100000);
                 zScope1->Channel2= (t5/100000);
                 zScope2->Channel1= (t6/100000);
                 zScope2->Channel2= (t7/100000);
                };

            zPanelMeter1->Value=abs(t6/100000);
            zPanelMeter3->Value=abs(t7/100000);
            zPanelMeter2->Value=abs(t4/100000);
            zPanelMeter4->Value=abs(t5/100000);

            Panel8->Caption=IntToStr(t6);
            Panel9->Caption=IntToStr(t4);
            Panel10->Caption=IntToStr(t7);
            Panel11->Caption=IntToStr(t5);

  };

 t2=passa_avanti(t2-1);
 t2=16;
 t3=t3+1;
 };
 };
}
//---------------------------------------------------------------------------
//funzione step
void __fastcall TForm1::Button2Click(TObject *Sender)
{
step=true;
Button1->Click();
Edit1->Text=base1;
Panel5->Caption=IntToStr(Kpr);

 if (Kpr<StrToInt(Panel6->Caption))
          Panel6->Caption=IntToStr(Kpr);

 if (Kpr>StrToInt(Panel7->Caption))
          Panel7->Caption=IntToStr(Kpr);
}
//---------------------------------------------------------------------------
//funzione reset degli oscilloscopi
void __fastcall TForm1::Button3Click(TObject *Sender)
{
int t;
for (t=0;t<1000;t++)
        beam[t]=0;
        
zScope1->SetAllChannel1(beam) ;
zScope1->SetAllChannel2(beam);
zScope2->SetAllChannel1(beam) ;
zScope2->SetAllChannel2(beam);
}
//---------------------------------------------------------------------------


